xargs short-circuit

Matthew Story matthewstory at gmail.com
Tue Feb 14 19:18:29 UTC 2012


On Tue, Feb 14, 2012 at 2:05 PM, Devin Teske <devin.teske at fisglobal.com>wrote:

>
>
> > -----Original Message-----
> > From: owner-freebsd-hackers at freebsd.org [mailto:owner-freebsd-
> > hackers at freebsd.org] On Behalf Of Matthew Story
> > Sent: Tuesday, February 14, 2012 10:35 AM
> > To: freebsd-hackers at freebsd.org
> > Subject: xargs short-circuit
> >
> > After reading the man-page, and browsing around the internet for a
> minute,
> > I was just wondering if there is an option in (any) xargs to
> short-circuit
> > on first failure of [utility [arguments]].
> >
> > e.g.
> >
> > $ jot - 1 10 | xargs -e -n1 sh -c 'echo "$*"; echo exit 1' worker ||
> echo $?
> > 1
> > 1
> >
> > such that any non-0 exit code in a child process would cause xargs to
> stop
> > processing.  seems like this would be a nice feature to have.
> >
>
> You can achieve this quite easily with a sub-shell:
>
> As a bourne-shell script:
>
> #!/bin/sh
> jot - 1 10 | ( while read ARG1 REST; do
>        sh -c 'echo "$*"; exit 1' worker $ARG1 || exit $?
>        shift 1
> done )
>

read is often not sufficient for a variety of reasons, the most notable of
them is that new-lines are valid in file names on most file systems.  While
some shells do support a variety of options, POSIX only supports -r (raw,
treat backslashes as literal, not escape).

find . -print0 | xargs -0 -e ...

Is vastly nicer in most cases.  Additionally, xargs provides the
possibility of concurrency, via -P ... while you can spoof this with
trailing & and wait(1) in sh, this is both vastly more complicated than
xargs -P, and not as efficient in spawning jobs, it would be nice to be
able to have xargs stop spawning new jobs on first failure in this case,
and exit at last reap of existing child processes if the short-circuit flag
is sent:

find . -print0 | xargs -n1 -0 -e -P4 ...

My use-case is a CPU-bound operation running with concurrency and many more
jobs than concurrency, on failure xargs continues to work until finished to
report failure, which is a large number of wasted cycles, and box load.
 Would be nice to bail as early as possible in situations where any failure
is fatal to the larger operation.


>
> Or interactively in sh/bash:
>
> $ jot - 1 10 | ( while read ARG1 REST; do sh -c 'echo "$*"; exit 1' worker
> $ARG1
> || exit $?; shift 1;done )
>
> Or interactively in csh/tcsh:
>
> % jot - 1 10 | /bin/sh -c 'while read ARG1 REST; do sh -c '\''echo "$*";
> exit
> 1'\'' worker $ARG1 || exit $?; shift 1; done'
>
> --
> Devin
>
> _____________
> The information contained in this message is proprietary and/or
> confidential. If you are not the intended recipient, please: (i) delete the
> message and all copies; (ii) do not disclose, distribute or use the message
> in any manner; and (iii) notify the sender immediately. In addition, please
> be aware that any message addressed to our domain is subject to archiving
> and review by persons other than the intended recipient. Thank you.
>



-- 
regards,
matt


More information about the freebsd-hackers mailing list